diff --git a/Tmain/unreadable-input.d/input-1.c b/Tmain/unreadable-input.d/input-1.c
new file mode 100644
index 0000000000..c536f0b878
--- /dev/null
+++ b/Tmain/unreadable-input.d/input-1.c
@@ -0,0 +1 @@
+int v1;
diff --git a/Tmain/unreadable-input.d/stderr-expected.txt b/Tmain/unreadable-input.d/stderr-expected.txt
new file mode 100644
index 0000000000..732a03ccb8
--- /dev/null
+++ b/Tmain/unreadable-input.d/stderr-expected.txt
@@ -0,0 +1 @@
+ctags: Warning: cannot open "input-0.c" : Permission denied
diff --git a/Tmain/unreadable-input.d/stdout-expected.txt b/Tmain/unreadable-input.d/stdout-expected.txt
new file mode 100644
index 0000000000..9b6a39c989
--- /dev/null
+++ b/Tmain/unreadable-input.d/stdout-expected.txt
@@ -0,0 +1 @@
+v1	input-1.c	/^int v1;$/;"	v	typeref:typename:int
diff --git a/main/parse.c b/main/parse.c
index cff1a548fa..2e03e51666 100644
--- a/main/parse.c
+++ b/main/parse.c
@@ -3890,7 +3890,7 @@ extern bool runParserInNarrowedInputStream (const langType language,
 
 static bool createTagsWithFallback (
 	const char *const fileName, const langType language,
-	MIO *mio)
+	MIO *mio, bool *failureInOpenning)
 {
 	langType exclusive_subparser = LANG_IGNORE;
 	bool tagFileResized = false;
@@ -3898,7 +3898,13 @@ static bool createTagsWithFallback (
 	Assert (0 <= language  &&  language < (int) LanguageCount);
 
 	if (!openInputFile (fileName, language, mio))
+	{
+		if (failureInOpenning)
+			*failureInOpenning = true;
 		return false;
+	}
+	if (*failureInOpenning)
+		*failureInOpenning = false;
 
 	tagFileResized = createTagsWithFallback1 (language,
 											  &exclusive_subparser);
@@ -4054,6 +4060,7 @@ static bool parseMio (const char *const fileName, langType language, MIO* mio, b
 					  void *clientData)
 {
 	bool tagFileResized = false;
+	bool failureInOpenning = false;
 
 	setupWriter (clientData);
 
@@ -4061,13 +4068,13 @@ static bool parseMio (const char *const fileName, langType language, MIO* mio, b
 
 	initParserTrashBox ();
 
-	tagFileResized = createTagsWithFallback (fileName, language, mio);
+	tagFileResized = createTagsWithFallback (fileName, language, mio, &failureInOpenning);
 
 	finiParserTrashBox ();
 
 	teardownAnon ();
 
-	if (useSourceFileTagPath)
+	if (useSourceFileTagPath && (!failureInOpenning))
 		return teardownWriter (getSourceFileTagPath())? true: tagFileResized;
 	else
 		return teardownWriter(fileName);
